# NOTES:
#
# Patch product which replaces zopes webdav.xmltools with new version.
# We also replace the imported class in davcmds.
#
# The reason for this patch is a severe memory leak in zopes standard
# webdav.xmltools module which never cleans up the xmltools.Document instances.
# The problem only pops up when you send webdav requests containing an xml body.
# Each request leaks one xmltools.Document instance which is never cleaned up.
#
# To fix this simply add this product into you product folder. This will replace
# zopes webdav.xmltools package by a new one which uses minidom to parse the 
# xml requests instead of the obsolete xmllib package.
#
# for questions contact simon@struktur.de.
# see http://www.icoya.com


import sys
import webdav

import ixmltools

sys.modules['webdav.xmltools']=ixmltools
webdav.xmltools = ixmltools
webdav.davcmds.XmlParser=ixmltools.XmlParser
