"""
/**********************************************************************
FILE     : $RCSfile: ixmltools.py,v $
PURPOSE  : simple replacement for zopes webdav.xmltools parser
NOTES    : we use minidom instead of xmllib to parse the request body
AUTHOR   : Simon Eisenmann
COPYRIGHT: (c) 2004 by struktur AG
DATE     : 28Jul2004
REVISION : $Revision: 1.6 $
VERSION  : $Id: ixmltools.py,v 1.6 2004/09/14 10:59:26 longsleep Exp $ (Author: $Author: longsleep $)

struktur AG            Phone: +49 711 8966560
Friedrichstr. 5         Fax:   +49 711 89665610
70174 Stuttgart        email: info@struktur.de
GERMANY

http://www.struktur.de
http://www.strukturag.com

**********************************************************************/
"""


from xml.dom import minidom


class Node:
    """ our nodes """
    
    node = None
    
    def __init__(self, node):
        self.node=node
        
    def elements(self, name=None, ns=None):
        nodes=[ Node(n) for n in self.node.childNodes if n.nodeType == n.ELEMENT_NODE and \
                                                   ((name is None) or ((n.localName.lower())==name)) and \
                                                   ((ns is None) or (n.namespaceURI==ns)) ]
        return nodes

    def qname(self):
        return '%s%s' % (self.namespace(), self.name()) 
        
    def addNode(self, node):
        raise NotImplementedError, 'addNode not implemented'

    def toxml(self):
        return self.node.toxml()
        
    def strval(self):
        return self.toxml()
        
    def name(self):  return self.node.localName
    def attrs(self): return self.node.attributes
    def value(self): return self.node.nodeValue
    def nodes(self): return self.node.childNodes
    def nskey(self): return self.node.namespaceURI
    
    def namespace(self): return self.nskey()
   
    def remap(self, dict, n=0, top=1):
        # XXX: this method is used to do some strange remapping of elements
        #      and namespaces .. not sure how to do this with minidom
        #      and if this is even required for something
        return {},0
 
    def __repr__(self):
        if self.namespace():
            return "<Node %s (from %s)>" % (self.name(), self.namespace())
        else: return "<Node %s>" % self.name()


class XmlParser:
    """ simple wrapper around minidom to support the required 
        interfaces for zope.webdav
    """

    dom = None
    
    def __init__(self):
        #print "using new parser"
        pass
        
    def parse(self, data):
        self.dom=minidom.parseString(data)
        return Node(self.dom)
        
    
